<?
class image {
	public	$filename, $width, $height, $font, $color, $margin, $image;

	function __construct($width,$height = 0,$truecolor = 0) {
		if($height) {
			$this->image 	= imagecreatetruecolor($width,$height);
			$this->width	= $width;
			$this->height	= $height;
			}
		else {
			$types = array('','gif','jpg','png');
			$this->filename = $width;

			$stats = getimagesize($this->filename);
			$ext = $types[$stats[2]];

			if($ext == 'gif')		$this->image = imagecreatefromgif($this->filename);
			else if($ext == 'png')	$this->image = imagecreatefrompng($this->filename);
			else					$this->image = imagecreatefromjpeg($this->filename);

			if(!$this->image) return(false);

			$this->width	= imagesx($this->image);
			$this->height	= imagesy($this->image);

			if($truecolor) {
				$image_temp = imagecreatetruecolor($this->width,$this->height);
				$trans		= imagecolorallocatealpha($this->image, 0, 0, 0, 127);
				imagecolortransparent($this->image, $trans);
				imagecopy($image_temp,$this->image,0,0,0,0,$this->width,$this->height);
				$this->image = $image_temp;
				}
			}
		$this->color(0,0,0);
		}

	function font($font = "") {
		if(!$font) return $this->font;
		else {
			if(!file_exists($font)) die("Can't locate font file $font");
			$this->font = $font;
			}
		}

	function margin($margin = "") {
		if($margin == "") return $this->margin;
		$this->margin = $margin;
		}

	function color($r = "",$g = "",$b = "") {
		$this->color = imagecolorallocate($this->image,$r,$g,$b);
		}

	function lighten($degree) {
		for($y=0; $y<$this->height; $y++)
			for($x=0; $x<$this->width; $x++)
				$this->lighten_pixel($degree,$x,$y);
		}

	function lighten_pixel($degree,$x,$y) {
		$color = imagecolorat($this->image,$x,$y);
		$r = ($color >> 16) & 0xff;
		$g = ($color >> 8)  & 0xff;
		$b = ($color)       & 0xff;
		$r += $degree;
		$g += $degree;
		$b += $degree;
		if($r < 0) $r = 0;
		else if($r > 255) $r = 255;
		if($g < 0) $g = 0;
		else if($g > 255) $g = 255;
		if($b < 0) $b = 0;
		else if($b > 255) $b = 255;
		imagesetpixel($this->image,$x,$y,imagecolorallocate($this->image,$r,$g,$b));
		}

	function bevel($depth) {
		$fade = 10;

		for($level=0; $level < $depth; $level++) {
			// Left
			$x = $level;
			for($y=$level+1; $y<($this->height-$level); $y++)
				$this->lighten_pixel(($depth - $level)*$fade,$x,$y);
			// Top
			$y = $level;
			for($x=$level; $x<($this->width-$level); $x++)
				$this->lighten_pixel(($depth - $level)*$fade,$x,$y);
			// Right
			$x = $this->width-1-$level;
			for($y=$level+1; $y<($this->height-$level); $y++)
				$this->lighten_pixel(($depth - $level)*$fade*-1,$x,$y);
			// Bottom
			$y = $this->height-1-$level;
			for($x=$level+1; $x<($this->width-$level-1); $x++)
				$this->lighten_pixel(($depth - $level)*$fade*-1,$x,$y);
			}
		}

	function pixel($x,$y,$r,$g=0,$b=0) {
		if($r<0)	$color = $this->color;
		else		$color = imagecolorallocate($this->image,$r,$g,$b);
		imagesetpixel($this->image,$x,$y,$color);
		}

	function resize($max_w, $max_h = 0) {
		$raw_image	= $this->image;
		$raw_w		= $this->width;
		$raw_h		= $this->height;
		$ratio		= $raw_w / $raw_h;

		$final_w	= $raw_w;
		$final_h	= $raw_h;
		if($max_h && ($final_h > $max_h)) {
			// Image is too high.  Resize to h = $max_h.
			$final_h	= $max_h;
			$final_w	= $final_h * $ratio;
			}
		if($max_w && ($final_w > $max_w)) {
			// Image is too wide.  Resize to w = $max_w.
			$final_w	= $max_w;
			$final_h	= $final_w / $ratio;
			}

		$final_image	= imagecreatetruecolor($final_w, $final_h);
		imagecopyresampled($final_image, $raw_image, 0, 0, 0, 0, $final_w, $final_h, $raw_w, $raw_h);
		$this->width	= $final_w;
		$this->height	= $final_h;
		$this->image	= $final_image;
		}

	function rotate() {
		$buffer			= $this->height;
		$this->height	= $this->width;
		$this->width	= $buffer;
		$temp_image = imagecreatetruecolor($this->width,$this->height);
		$temp_image = imagerotate($this->image,-90,imagecolorallocate($temp_image,0,0,0));
		$this->image = $temp_image;
		}

	function decal($filename,$x,$y) {
		$decal = new image($filename);
		imagecopy($this->image,$decal->image,$x,$y,0,0,$decal->width,$decal->height);
		}

	function decal_center($filename,$x,$y) {
		$decal = new image($filename);
		imagealphablending($this->image,TRUE);
		$x -= (int)($decal->width/2);
		$y -= (int)($decal->height/2);
		imagecopy($this->image,$decal->image,$x,$y,0,0,$decal->width,$decal->height);
		}

	function text($string, $size, $x = 0, $y = 0) {
		$bounds = imagettfbbox($size,0,$this->font,$string);
		$height = $bounds[7]-$bounds[1];
		$y -= ($height/2.5);
		imagettftext($this->image,$size,0,$x,$y,$this->color,$this->font,$string);

		return $height;
		}

	function text_center($string, $size, $y = 0, $bottom = 0, $leading = 0.25) {
		$bounds				= imagettfbbox($size,0,$this->font,$string);
		$width				= $bounds[2] - $bounds[0];
		$height				= $bounds[1] - $bounds[7];
		$width_effective	= $this->width - ($this->margin*2);

		foreach(preg_split("|\r?\n|",$string) as $line) if(($line_length = strlen($line)) > $string_length) $string_length = $line_length;
		$maxlength = (($width > $width_effective)?(int)($string_length/($width/$width_effective)):$string_length);

		$lines = $this->wordwrap_array($string,$maxlength);
		if($bottom) $lines = array_reverse($lines);
		foreach($lines as $line) {
			$bounds	= imagettfbbox($size,0,$this->font,$line);
			$width	= $bounds[2] - $bounds[0];
			$height	= $bounds[1] - $bounds[7];
			$height_total += $height;
			if($l++) $height_total += $leading * $size;
			$x			= (($this->width - $width)/2);
			$y_current	= (($bottom)?$y-$height_total+$height-$bounds[3]:$y+$height_total-$bounds[3]);
			imagettftext($this->image,$size,0,$x,$y_current,$this->color,$this->font,$line);
			}

		return $y_current-$y;
		}

	function line($x1,$y1,$x2,$y2,$dashed = 0,$brush_filename = "") {
		if($brush_filename) {
			$brush = new image($brush_filename);
			imagesetbrush($this->image,$brush->image);
			if($dashed)	imagedashedline($this->image,$x1,$y1,$x2,$y2,IMG_COLOR_BRUSHED);
			else		imageline($this->image,$x1,$y1,$x2,$y2,IMG_COLOR_BRUSHED);
			}
		else {
			if($dashed)	imagedashedline($this->image,$x1,$y1,$x2,$y2,$this->color);
			else		imageline($this->image,$x1,$y1,$x2,$y2,$this->color);
			}
		}

	function output($filename = "") {
		if(!$filename) $filename = $this->filename;
		imagejpeg($this->image, $filename, 100);
		}

	function output_http() {
		header("Content-type: image/jpeg");
		imagejpeg($this->image, "", 100);
		}

	private function wordwrap_array($string,$maxlength) {
		foreach(preg_split("|\r?\n|",$string) as $string) {
			do {
				$i = strlen($string);
				if($i > $maxlength) for($i = $maxlength; $string{$i} != ' '; $i--);
				$substrings[] = substr($string,0,$i);
				$string = substr($string,$i+1);
				} while($string);
			}

		return $substrings;
		}

	}
?>
